%esempio di modulazione e demodulazione AM (nel dettaglio DSB-SC)


clc
clear all
close all

%definizione asse temporale
tmin=0;
tmax=100;
dt=0.001;
t=tmin:dt:tmax;

% segnale modulante (in questo caso un rect centrata in 4 e larga 3 [s]) 
x=zeros(1,length(t));
x(t>3.5 & t<6.5)=1;
figure,plot(t,x)

% definizone della portante
f0=10;
xc=cos(2*pi*f0*t);

%trasformata di fourier del segnale modulante
fmax=1/dt;
f=linspace(-fmax/2,fmax/2,length(t));
X=fftshift(fft(x));
figure,plot(f,abs(X))

% modulazione e visualizzazione nel tempo e in frequenza del segnale
% modulato
xm=x.*xc;
figure,plot(t,xm)
Xm=fftshift(fft(xm));
figure,plot(f,abs(Xm))

% demodulazione e visualizzazione nel tempo del segnale demodulato
xmm=xm.*xc; % prodotto con la portante (produco repliche dello spettro 
% centrate intorno alla frequenza "0" e intorno a 2*frequenza_della_portante,
%N.B. è importante moltiplicare per una sinusoide che abbia esattamente la stessa 
%frequenza del segnale portante per evitare artefatti)
Xmm=fftshift(fft(xmm));
figure,plot(f,abs(Xmm))
H=zeros(1,length(t)); % filtro passa basso per eliminare le repliche dello 
%spettro centrate in 2*frequenza_della_portante
H(abs(f)<13)=1;
Xf=Xmm.*H;
xf=ifft(ifftshift(Xf)); %segnale demodulato nel dominio del tempo
figure,plot(t,xf)
%N.B. per un segnale a durata limitata (come quello scelto in questo
%esempio)l'operazione di modulazione/demodulazione ha comportato una
%degradazione del segnale evidenziata da oscillazioni visibili nel segnale
%ricostruito che non era presenti nel segnale originale (fenomeno di Gibbs)