%soluzione esercitazione 1

clc
clear all
close all

%definizione asse temporale
tmin=-50;
tmax=50;
fc=5e3; % 5 [kHz]
dt=1/(5*fc); % scelgo un passo di campionamento opportuno
t=tmin:dt:tmax;

%Punto 1)
%implementazione e rappresentazione del segnale m(t)
x1=zeros(1,length(t));
x2=zeros(1,length(t));
x3=zeros(1,length(t));
x1(abs(t)<2)=1;
x2(abs(t)<4)=1;
x3(t>0 & t<1)=1;
x=x1+x2+x3;
figure(1),plot(t,x)

% Punto 2)
% trasformata di fourier e visualizzazione dello spettrro di ampiezza
fmax=5*fc;  %viene da rigo 12
f=linspace(-fmax/2,fmax/2,length(t));
X=fftshift(fft(x));
figure(2),plot(f,abs(X))

% Punto 3) 
% aggiunta rumore gaussiano
n=sqrt(2)*randn(1,length(t));
x_n=x+n;

% Punto 4)
% modulazione DSB-SC
carrier=cos(2*pi*t*fc);
x_m=x_n.*carrier;

% Punto 5)
% Visualizzazione segnale modulato in tempo e in frequenza
figure(3),plot(t,x_m)
X_m=fftshift(fft(x_m));
figure(4),plot(f,abs(X_m))

% Punto 6)
% Filtraggio del segnale modulato nel dominio della frequenza
Hb=zeros(1,length(t));
Hb(abs(f)<5010)=1;
Hb(abs(f)<4990)=0;
X_f=X_m.*Hb;

% Punto 7)
% Demodulazione del segnale filtrato e visualizzazione nel dominio del
% tempo
%X_f=X_m; %da decommentare per il punto 8)
x_f=ifft(ifftshift(X_f));
x_d=x_f.*carrier;
Hl=zeros(1,length(t));
Hl(abs(f)<10)=1;
X_d=fftshift(fft(x_d));
X_df=X_d.*Hl;
x_df=ifft(ifftshift(X_df));
figure,plot(t,x_df)

% Punto 8)
%Ripeterre l'esercitazione invertendo i punto 6) e 7)
%Basterà provare ad eseguire il codice commentato le righe del punto 6) e
%decommentare riga 58

%N.B. le frequenze di taglio dei vari filtri sono parametri modificabili
%provare a cambiare tali valori e verificare il risultato finale